<Appenders>
    <!--  Note it appears that nested elements, i.e. this file, don't support <Properties /> so some filter strings below might be duplicated -->
    <!--
    Reference:
    https://logging.apache.org/log4j/2.x/manual/appenders.html#SyslogAppender
    http://logging.apache.org/log4j/2.x/manual/layouts.html#RFC5424Layout
    http://www.rsyslog.com/doc/v8-stable/configuration/modules/mmpstrucdata.html

    ** NOTE ** : see the readme for instructions on getting local dev logs setup.
     -->
    <Syslog name="default.syslog"
            format="RFC5424"
            id="${ServiceName}"
            host="localhost"
            port="514"
            protocol="UDP"
            appName="fx-demo"
            mdcId="af-mdc"
            includeMDC="true"
            facility="LOCAL0"
            newLine="true">
        <!--<Filters>-->
            <!--<RegexFilter regex="(?s).*(eartbeat|priceUpdate)(?s).*" onMatch="DENY" onMismatch="ACCEPT"/>-->
        <!--</Filters>-->
        <LoggerFields>
            <!--
            RFC5424Layout doesn't have all the bits you'd expect by default, you need to use 'structure data'
            'Structured Data' can be added when includeMDC is true and we provide LoggerFields.
            In rsyslog we can then use the mmpstrucdata module to extract it and build the appropriate logging template.

            The various layout variables (for the 'values') are here:  https://logging.apache.org/log4j/2.0/manual/layouts.html#PatternLayout
            -->
            <KeyValuePair key="thread" value="%t" />
            <KeyValuePair key="priority" value="%p" />
            <KeyValuePair key="logger" value="%C{1}" />
            <KeyValuePair key="exception" value="%ex"/>
        </LoggerFields>
    </Syslog>
    <Console name="default.console" target="SYSTEM_OUT">
        <!-- note that %.-1500msg is truncating %msg to 1500 characters. See https://logging.apache.org/log4j/2.x/manual/layouts.html -->
        <PatternLayout pattern="%highlight{%d{HH:mm:ss.SSS} [%t] %-5level %logger{36} - %.-1500msg%n}{FATAL=red bold, ERROR=red, WARN=yellow, INFO=green, DEBUG=white, TRACE=black}"/>
        <Filters>
            <!-- ignore heartbeats and prices, these at TRACE so also won't appear in the console.
             given this really these filter should only apply when trace is on, else why bother running them
             (?s) makes the following wildcard multiline (see Pattern.DOTALL https://docs.oracle.com/javase/tutorial/essential/regex/pattern.html) -->
            <RegexFilter regex="(?s).*(eartbeat|priceUpdate)(?s).*" onMatch="DENY" onMismatch="ACCEPT"/>
        </Filters>
    </Console>
</Appenders>